""" Least Square Solver"""

 """ Importing different functions needed"""
from __future__ import division                                         
from numpy import zeros, cos, sin, complex, array, asarray, reshape
""" Importing least square solver from numpy"""
from numpy.linalg import lstsq                                          
from math import pi
import numpy as np


""" Defining constants"""
omega = 2*pi/22.6                   
phase = 0
ampl = 6
rho = 1025
g=9.81
r=18.75



 """Shifts between which signal to apply the LSQ to."""
# Read signal
t, signal = np.loadtxt('total_6.txt', unpack=True)             
#t, signal = np.loadtxt('pressure_6.txt', unpack=True)          
#t, signal = np.loadtxt('visc_data_4m.txt', unpack=True)

""" Filter, removes the first 30 seconds to ensure a stabilized signal"""
sieve = t > 30                                                  
t2 = t[sieve]
signal2 = signal[sieve]

"""Makes Matrix with four columns, 1. const, 2. velocity, 3. acceleration"""
N = len(t2)
Mx = zeros((N, 4), float)  

""" Heave displacement """
etta_3=-ampl*cos(omega*t2 + phase)   
""" Water plane area """
Aw =pi*r**2                          

""" Restoring force"""
res =rho*g*Aw*etta_3                
""" Removing the restoring signal, keeping only damping and mass terms""" 
signal3=signal2+res   
""" Defining speed"""              
v = ampl*omega*sin(omega*t2 + phase)
""" Defining acceleration"""   
a = ampl*omega**2*cos(omega*t2 + phase) 

Mx[:,0] = 1
Mx[:,1] = v
#Mx[:,2] = v*np.abs(v)
Mx[:,2] = a
#Mx[:,4] = a*np.abs(a)

"""Perform least square fit. Return the least-squares solution to a linear matrix equation.""" 
(p, residuals, rank, s) = lstsq(Mx, signal3)    

print p

# Best fit signal
const = p[0]
res = np.dot(Mx, p)


 """ Plotting the results""" 
import matplotlib.pyplot as plt                    
plt.plot(t, signal, 'k', lw=2, label='Original')
plt.plot(t2, res, label='Best fit')
for i in range(4):
    plt.plot(t2, Mx[:,i]*p[i], label='Column %d' % i)
plt.plot(t2,p[1]*v+p[2]*a,label='Refit')
print p[1], p[2], p[3]
plt.legend()
plt.show()